# -*- coding: utf-8 -*-


class FileTag:
    try:
        import dbus

        __keywords = dbus.Interface(
                dbus.SessionBus().get_object('org.freedesktop.Tracker',
                                   '/org/freedesktop/tracker')
                , 'org.freedesktop.Tracker.Keywords')
    except:
        __keywords = None

    def __init__(self,f):
        if FileTag.__keywords:
            self.__file = f
            self.__load()
        else:
            raise Exception("dbus/tracker not present")

    def __load(self):
        self.__l = list(FileTag.__keywords.Get("Files",self.__file))

    def __repr__(self):
        return str(self.__l)

    def add(self,t):
        """ add a tag (unicode)"""
        assert type(t)==unicode
        if t not in self.__l:
            FileTag.__keywords.Add("Files",self.__file,[t,])
            self.__load()

    def sub(self,t):
        """ sub a tag (unicode)"""
        assert type(t)==unicode
        if t in self.__l:
            FileTag.__keywords.Remove("Files",self.__file,[t,])
            self.__load()

    def clean(self):
        """ clear all tags """
        if self.__l:
            FileTag.__keywords.Remove("Files",self.__file,self.__l)
        self.__load()


if __name__ == "__main__":
    from lxml.etree import Element,ElementTree
    import lxml
    import os
    root = ElementTree(file="/home/manatlan/.jbrout/db.xml").getroot()
    taggedNodes=root.xpath(u"""//photo[t]""")
    for node in taggedNodes:
        file = unicode(os.path.join(node.getparent().get("name"),node.get("name")))
        tags = [unicode(i.text) for i in node.xpath("t")]
        
        tt = FileTag(file)
        tt.clean()
        for t in tags:
            tt.add(t)
        print taggedNodes.index(node),len(taggedNodes)

    #f="/home/manatlan/Desktop/logo.png"
    #a=FileTag(f)
    #print a
    #a.add(u"jé")
    #a.add(u"jék")
    #print a
    ##~ a.sub(u"jé")
    #a.clean()
    #print a
